## ros-rolling-rmw-connext-cpp 3.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rmw_connext_cpp)

if(DEFINED ENV{CONNEXT_STATIC_DISABLE})
  set(disable_static_connext $ENV{CONNEXT_STATIC_DISABLE})
else()
  set(disable_static_connext FALSE)
endif()
set(CONNEXT_STATIC_DISABLE ${disable_static_connext}
  CACHE BOOL "If Connext Static should be disabled.")

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)

find_package(connext_cmake_module REQUIRED)
find_package(Connext QUIET MODULE)
if(Connext_FOUND)
  find_package(Connext MODULE)
endif()
if(NOT Connext_FOUND OR CONNEXT_STATIC_DISABLE)
  ament_package()
  if(NOT Connext_FOUND)
    message(WARNING "Could not find RTI Connext - skipping '${PROJECT_NAME}'")
  else()
    message(STATUS "Connext static rmw implementation explicitly disabled - skipping '${PROJECT_NAME}'")
  endif()
  return()
endif()

find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)

find_package(rosidl_typesupport_connext_c)
if(NOT rosidl_typesupport_connext_c_FOUND)
  ament_package()
  message(WARNING
    "Could not find ROSIDL TypeSupport for Connext (rosidl_typesupport_connext_c) - skipping '${PROJECT_NAME}'")
  return()
endif()

find_package(rosidl_typesupport_connext_cpp)
if(NOT rosidl_typesupport_connext_cpp_FOUND)
  ament_package()
  message(WARNING
    "Could not find ROSIDL TypeSupport for Connext (rosidl_typesupport_connext_cpp) - skipping '${PROJECT_NAME}'")
  return()
endif()

find_package(rmw REQUIRED)
find_package(rmw_connext_shared_cpp REQUIRED)
find_package(rosidl_runtime_c REQUIRED)
find_package(rosidl_runtime_cpp REQUIRED)

include_directories(include)

ament_export_include_directories(include)
ament_export_dependencies(
  rcpputils
  rcutils
  rmw
  rmw_connext_shared_cpp
  rosidl_runtime_c
  rosidl_runtime_cpp
  rosidl_typesupport_connext_c
  rosidl_typesupport_connext_cpp)

register_rmw_implementation(
  "c:rosidl_typesupport_c:rosidl_typesupport_connext_c"
  "cpp:rosidl_typesupport_cpp:rosidl_typesupport_connext_cpp"
)

# generate code for raw data
set(generated_directory "${CMAKE_CURRENT_BINARY_DIR}/resources/generated")
file(MAKE_DIRECTORY ${generated_directory})
set(generated_files
  ${generated_directory}/connext_static_serialized_data.cxx
  ${generated_directory}/connext_static_serialized_data.h
  ${generated_directory}/connext_static_serialized_dataPlugin.cxx
  ${generated_directory}/connext_static_serialized_dataPlugin.h
  ${generated_directory}/connext_static_serialized_dataSupport.cxx
  ${generated_directory}/connext_static_serialized_dataSupport.h
)
add_custom_command(
  OUTPUT ${generated_files}
  # We *explicitly* do not use Connext_DDSGEN_SERVER here.  The other time we invoke the
  # server is in rosidl_typesupport_connext_cpp, and that uses a different set of arguments.
  # We don't want to accidentally connect to that other version of the server that might
  # still be running.
  COMMAND
    "${Connext_DDSGEN}" -language C++ -unboundedSupport "connext_static_serialized_data.idl" -d ${generated_directory}
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/resources"
  COMMENT "Generating serialized type support for RTI Connext (using '${Connext_DDSGEN}')"
  VERBATIM
)

# determine major version of Connext
find_file(connext_version_header "ndds_version.h"
  PATHS ${Connext_INCLUDE_DIRS}
  PATH_SUFFIXES "ndds"
  NO_DEFAULT_PATH)
if(NOT connext_version_header)
  message(FATAL_ERROR "Failed to find 'ndds/ndds_version.h' in '${Connext_INCLUDE_DIRS}'")
endif()
file(STRINGS "${connext_version_header}" connext_define_major_version
  LIMIT_COUNT 1
  REGEX "#define RTI_DDS_VERSION_MAJOR  [0-9]+")
if("${connext_define_major_version}" STREQUAL "")
  message(FATAL_ERROR "Failed to find '#define RTI_DDS_VERSION_MAJOR' in '${connext_version_header}'")
endif()
string(REGEX REPLACE ".* ([0-9]+)" "\\1" connext_major_version "${connext_define_major_version}")

# patch the generate code for raw data
if("${connext_major_version}" LESS 6)
  set(patch_files_subdirectory "patch_files")
else()
  set(patch_files_subdirectory "patch_files_v6")
endif()
set(patch_files
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_data.cxx.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_data.h.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataPlugin.cxx.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataPlugin.h.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataSupport.cxx.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataSupport.h.patch
)
set(patched_directory "${CMAKE_CURRENT_BINARY_DIR}/resources/patched")
file(MAKE_DIRECTORY ${patched_directory})
set(patched_files
  ${patched_directory}/connext_static_serialized_data.cxx
  ${patched_directory}/connext_static_serialized_data.h
  ${patched_directory}/connext_static_serialized_dataPlugin.cxx
  ${patched_directory}/connext_static_serialized_dataPlugin.h
  ${patched_directory}/connext_static_serialized_dataSupport.cxx
  ${patched_directory}/connext_static_serialized_dataSupport.h
)
add_custom_command(
  OUTPUT ${patched_files}
  COMMAND
    ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/bin/apply-patch.py"
      --input ${generated_files}
      --patch ${patch_files}
      --out ${patched_files}
  DEPENDS ${generated_files}
  COMMENT "Patching serialized type support for RTI Connext"
  VERBATIM
)

add_library(
  rmw_connext_cpp
  SHARED
  ${patched_files}
  src/connext_static_publisher_info.cpp
  src/connext_static_subscriber_info.cpp
  src/get_client.cpp
  src/get_participant.cpp
  src/get_publisher.cpp
  src/get_service.cpp
  src/get_subscriber.cpp
  src/identifier.cpp
  src/process_topic_and_service_names.cpp
  src/rmw_client.cpp
  src/rmw_compare_gid_equals.cpp
  src/rmw_count.cpp
  src/rmw_event.cpp
  src/rmw_get_gid_for_publisher.cpp
  src/rmw_get_implementation_identifier.cpp
  src/rmw_get_serialization_format.cpp
  src/rmw_guard_condition.cpp
  src/rmw_init.cpp
  src/rmw_logging.cpp
  src/rmw_node.cpp
  src/rmw_node_info_and_types.cpp
  src/rmw_node_names.cpp
  src/rmw_publish.cpp
  src/rmw_publisher.cpp
  src/rmw_qos.cpp
  src/rmw_request.cpp
  src/rmw_response.cpp
  src/rmw_serialize.cpp
  src/rmw_service.cpp
  src/rmw_service_names_and_types.cpp
  src/rmw_service_server_is_available.cpp
  src/rmw_subscription.cpp
  src/rmw_take.cpp
  src/rmw_topic_names_and_types.cpp
  src/rmw_trigger_guard_condition.cpp
  src/rmw_wait.cpp
  src/rmw_wait_set.cpp
  src/serialization_format.cpp
  src/rmw_get_topic_endpoint_info.cpp)
ament_target_dependencies(rmw_connext_cpp
  "rcpputils"
  "rcutils"
  "rmw"
  "rmw_connext_shared_cpp"
  "rosidl_runtime_c"
  "rosidl_runtime_cpp"
  "rosidl_typesupport_connext_c"
  "rosidl_typesupport_connext_cpp"
  "Connext")
target_include_directories(rmw_connext_cpp PUBLIC ${patched_directory})
ament_export_libraries(rmw_connext_cpp)

# Causes the visibility macros to use dllexport rather than dllimport
# which is appropriate when building the library but not consuming it.
target_compile_definitions(rmw_connext_cpp
  PRIVATE "RMW_CONNEXT_CPP_BUILDING_DLL")

# On Windows this adds the RMW_BUILDING_DLL definition.
# On Unix (GCC or Clang) it hides the symbols with -fvisibility=hidden.
configure_rmw_library(rmw_connext_cpp)

if(WIN32)
  target_compile_definitions(rmw_connext_cpp
    PRIVATE "_CRT_NONSTDC_NO_DEPRECATE")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package(CONFIG_EXTRAS "${PROJECT_NAME}-extras.cmake")

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS rmw_connext_cpp
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

get_rmw_connext_output_filter("rmw_connext_output_filter")
ament_index_register_resource("rmw_output_prefixes" CONTENT "${rmw_connext_output_filter}")

=== debian/changelog ===
ros-rolling-rmw-connext-cpp (3.6.0-1focal) focal; urgency=high

  * Add RMW function to check QoS compatibility (#488 <https://github.com/ros2/rmw_connext/issues/488>)
  * Shorten some excessively long lines of CMake (#486 <https://github.com/ros2/rmw_connext/issues/486>)
  * Contributors: Jacob Perron, Scott K Logan

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Mon, 01 Mar 2021 08:00:00 -0000

ros-rolling-rmw-connext-cpp (3.5.1-1focal) focal; urgency=high

  * Handle typesupport errors on retrieval. (#483 <https://github.com/ros2/rmw_connext/issues/483>)
  * Contributors: Michel Hidalgo

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Mon, 25 Jan 2021 08:00:00 -0000

ros-rolling-rmw-connext-cpp (3.5.0-1focal) focal; urgency=high

  * typo fix for ConnextStaticSerializedDataSupport of subscription. (#475 <https://github.com/ros2/rmw_connext/issues/475>)
  * Allow more flexible usage of XML QoS profiles (#460 <https://github.com/ros2/rmw_connext/issues/460>)
  * Update maintainers (#468 <https://github.com/ros2/rmw_connext/issues/468>)
  * Contributors: Alejandro Hernández Cordero, Ivan Santiago Paunovic, tomoya

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Tue, 08 Dec 2020 08:00:00 -0000

ros-rolling-rmw-connext-cpp (3.4.2-1focal) focal; urgency=high

  * Return RMW_RET_UNSUPPORTED in rmw_get_serialized_message_size (#467 <https://github.com/ros2/rmw_connext/issues/467>)
  * Returned RMW_RET_INCORRECT_RMW_IMPLEMENTATION in rmw_service_server_is_available (#466 <https://github.com/ros2/rmw_connext/issues/466>)
  * Update service/client request/response API error returns (#465 <https://github.com/ros2/rmw_connext/issues/465>)
  * Contributors: Alejandro Hernández Cordero, Jose Tomas Lorente

 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 29 Sep 2020 07:00:00 -0000

ros-rolling-rmw-connext-cpp (3.4.1-1focal) focal; urgency=high

  * Updated publisher/subscription allocation and wait set API return codes. (#463 <https://github.com/ros2/rmw_connext/issues/463>)
  * Update service/client construction/destruction API return codes. (#464 <https://github.com/ros2/rmw_connext/issues/464>)
  * Contributors: Alejandro Hernández Cordero, Michel Hidalgo

 -- Dirk Thomas <dthomas@osrfoundation.org>  Sat, 26 Sep 2020 07:00:00 -0000

ros-rolling-rmw-connext-cpp (3.4.0-1focal) focal; urgency=high

  * Updated returns on rmw_take_serialized_with_info(). (#462 <https://github.com/ros2/rmw_connext/issues/462>)
  * Update gid API return codes. (#461 <https://github.com/ros2/rmw_connext/issues/461>)
  * Contributors: Jose Tomas Lorente, Michel Hidalgo

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 23 Sep 2020 07:00:00 -0000

ros-rolling-rmw-connext-cpp (3.3.0-1focal) focal; urgency=high

  * Fix wrong error messages (#458 <https://github.com/ros2/rmw_connext/issues/458>)
  * Update rmw_take_serialized() and rmw_take_with_error_info() error returns (#456 <https://github.com/ros2/rmw_connext/issues/456>)
  * Update rmw_take() error returns  (#454 <https://github.com/ros2/rmw_connext/issues/454>)
  * Update rmw_publish() error returns (#452 <https://github.com/ros2/rmw_connext/issues/452>)
  * Update rmw_publish_serialized_message() error returns (#453 <https://github.com/ros2/rmw_connext/issues/453>)
  * Contributors: Ivan Santiago Paunovic, Jose Tomas Lorente, Lobotuerk

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 18 Sep 2020 07:00:00 -0000

ros-rolling-rmw-connext-cpp (3.2.0-1focal) focal; urgency=high

  * Ensure compliant matched pub/sub count API. (#451 <https://github.com/ros2/rmw_connext/issues/451>)
  * Contributors: Michel Hidalgo

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 28 Aug 2020 07:00:00 -0000

ros-rolling-rmw-connext-cpp (3.1.0-1focal) focal; urgency=high

  * Ensure compliant subscription API. (#450 <https://github.com/ros2/rmw_connext/issues/450>)
  * Contributors: Michel Hidalgo

 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 06 Aug 2020 07:00:00 -0000

ros-rolling-rmw-connext-cpp (3.0.0-1focal) focal; urgency=high

  * Remove internal rmw_connext_cpp headers from public API. (#447 <https://github.com/ros2/rmw_connext/issues/447>)
    * Update rmw_connext_cpp after internal headers relocation.
    * Relocate internal rmw_connext_cpp headers.
  * Decouple rmw_destroy_publisher() outcome from global RMW error state. (#449 <https://github.com/ros2/rmw_connext/issues/449>)
  * Ensure compliant publisher API. (#445 <https://github.com/ros2/rmw_connext/issues/445>)
  * Avoid leaking DDS::Topic objects. (#444 <https://github.com/ros2/rmw_connext/issues/444>)
  * Contributors: Ivan Santiago Paunovic, Michel Hidalgo

 -- Dirk Thomas <dthomas@osrfoundation.org>  Mon, 03 Aug 2020 07:00:00 -0000

ros-rolling-rmw-connext-cpp (2.2.0-1focal) focal; urgency=high

  * Set context actual domain id (#443 <https://github.com/ros2/rmw_connext/issues/443>)
  * Contributors: Ivan Santiago Paunovic

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 22 Jul 2020 07:00:00 -0000

ros-rolling-rmw-connext-cpp (2.1.0-1focal) focal; urgency=high

  * Fix topic creation race condition (#442 <https://github.com/ros2/rmw_connext/issues/442>)
  * Ensure compliant node construction/destruction API (#439 <https://github.com/ros2/rmw_connext/issues/439>)
  * Improve error message when failing to create topic (#441 <https://github.com/ros2/rmw_connext/issues/441>)
  * Contributors: Ivan Santiago Paunovic, Michel Hidalgo

 -- Dirk Thomas <dthomas@osrfoundation.org>  Mon, 20 Jul 2020 07:00:00 -0000

ros-rolling-rmw-connext-cpp (2.0.0-1focal) focal; urgency=high

  * Remove domain_id and localhost_only from node API (#438 <https://github.com/ros2/rmw_connext/issues/438>)
  * Amend rmw_init() implementation: require enclave. (#437 <https://github.com/ros2/rmw_connext/issues/437>)
  * Contributors: Ivan Santiago Paunovic, Michel Hidalgo

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 08 Jul 2020 07:00:00 -0000



=== debian/control ===
Source: ros-rolling-rmw-connext-cpp
Section: misc
Priority: optional
Maintainer: Alejandro Hernandez Cordero <alejandro@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-connext-cmake-module, ros-rolling-rcpputils, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-rmw-connext-shared-cpp, ros-rolling-rosidl-cmake, ros-rolling-rosidl-generator-dds-idl, ros-rolling-rosidl-runtime-c, ros-rolling-rosidl-runtime-cpp, ros-rolling-rosidl-typesupport-connext-c, ros-rolling-rosidl-typesupport-connext-cpp, rti-connext-dds-5.3.1, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rmw-connext-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-ament-cmake, ros-rolling-connext-cmake-module, ros-rolling-rcpputils, ros-rolling-rcutils, ros-rolling-rmw, ros-rolling-rmw-connext-shared-cpp, ros-rolling-rosidl-cmake, ros-rolling-rosidl-runtime-c, ros-rolling-rosidl-runtime-cpp, ros-rolling-rosidl-typesupport-connext-c, ros-rolling-rosidl-typesupport-connext-cpp, rti-connext-dds-5.3.1, ros-rolling-ros-workspace
Description: Implement the ROS middleware interface using RTI Connext static code generation in C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rmw-connext-cpp//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install
